#include "labgen.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
char DIR[8][3] = {"N","NE","E","SE","S","SW","W","NW"};

Point size;
/*int in,out;*/
variables listevars;
variables listLAB;
variables listIDENT;
variables listCOUNT;
Point in;
/*Point** listOUT;*/

/* Crée un nouveau point de coordonnées (c,l)
 * --> Attention : l'ordre n'est pas logique (colonne, ligne)
 */
Point new_point(int c, int l)
{
  Point monpoint;
  monpoint.c = c;
  monpoint.l = l;
  return monpoint;
}


/* Crée un pointeur de point de coodonnées (c,l) */
Point* new_point_ptr(int c, int l){
  Point* res;
  res = malloc(sizeof(Point));
  *res = new_point(c,l);
  return res;
}


/* Crée une matrice de taille (s1, s2)
 * --> Attention : l'ordre n'est pas logique (colonne, ligne)
 * s1 est le nombre de colonnes
 * s2 est le nombre de lignes
 * Implémentation de la matrice en mode naturel <-------
 * /!\ Attention : toujours créer la matrice avant d'utiliser
 * les autres fonctions */
char*** create_matrice(int s1, int s2)
{
  int i,j;
  char*** matrice = malloc((s2+1)*sizeof(char **));

  for (i= 0; i<=s2; i++){
      matrice[i] = malloc((s1+1) * sizeof(char *));
      for (j=0; j<=s1; j++) {
        matrice[i][j] = malloc(sizeof(char));
        strcpy(matrice[i][j],"");
      }
  }
  size = new_point(s1,s2);
  /*in = 0;
  out = 0;*/
  return matrice;
}


/* Renvoie la valeur de la matrice de coordonnées p */
char* lecture(Point p, char*** matrice)
{
  if (matrice == NULL){
    printf("Matrice non initialisée.\n");
  }
  else if (p.c >= 0 && p.l >= 0 && p.c <= size.c && p.l <= size.l){
    return matrice[p.l][p.c];
  }
  else
    printf("Impossible de lire la valeur au point (%d,%d).\n", p.c,p.l);
  return NULL;
}


/* void stock_val */
/* Change la valeur de la matrice de coordonnées p par la valeur msg */
void change_val_matrice(Point p, char * msg, char*** matrice)
{
  if (matrice == NULL){
    printf("Matrice non initialisée.\n");
  }

  else if (p.c >= 0 && p.l >= 0 && p.c <= size.c && p.l <= size.l) {
      char * m1;
      m1 = malloc(strlen(msg)*sizeof(char));
      strcpy(m1,msg);
      if (matrice[p.l][p.c] != NULL){
        free(matrice[p.l][p.c]) ;
      }
      matrice[p.l][p.c] = m1;
  }
  else {
    printf("Impossible de changer de valeur la valeur au point (%d,%d).\n",
      p.c,p.l);
  }
}


void ligne(Point sizeLAB){
  int	j;
  printf(" +");
  for (j=0;j<=sizeLAB.c;j++)
    printf("----+");
  printf("\n");
}


void affichmat(char*** matrice, Point sizeLAB) {
  int	i,j;
  char* tmp;

  printf(" ");
  for (i=0; i<=sizeLAB.c; i++){
    printf("   %d ",i);
  }
  printf("\n");

  ligne(sizeLAB);
  for(i=0;i<=sizeLAB.l;i++){
    printf("%d",i);
    for(j=0;j<=sizeLAB.c;j++){
      tmp = matrice[i][j];
      if (strcmp(tmp,"") == 0){
        printf("|    ");
      }
      else
        printf("| %s ",tmp);
    }
    printf("|\n");
    ligne(sizeLAB);
  }
}

/* Crée un tableau de pointeurs à une dimension */
Point** init_tab(Point size){
  Point** res;
  int i;
  int taille = (size.c+1) * (size.l+1);

  res = calloc(taille,sizeof(Point*));
  for (i=0 ; i<taille ; i++)
    res[i] = malloc(sizeof(Point));
  return res;
}


/* Vérifie que deux points sont identiques
 * Si égaux retourne 1, sinon retourne 0 */
int equals_pt(Point pt1, Point pt2){
  if (pt1.c == pt2.c && pt1.l == pt2.l)
    return 1;
  return 0;
}


/* Ajouter pt à tab */
Point** add_tab(Point pt, Point** tab, int taille){
  int i;
  /* Ajouter condition quand dépassement de taille */
  /* On vérifie que le point à mettre n'est pas déjà dans tab */
  for (i=0 ; i<taille ; i++){
    if (1 == equals_pt(pt,*(tab[i]))){
      /*listCOUNT = increment_var(ident,listCOUNT);*/
      return tab;
    }
  }
  /*Vérifier pour l'incrémentation de la taille*/
  *(tab[taille]) = pt;
  return tab;
}



/******************************************************************************/
/* Fonctions de base de listevars                                             */
/******************************************************************************/


/* Initialise listevars */
variables init_listevars(){
  variables res;
  res.last = 0;
  return res;
}


/* Vérifie si var est dans listevars :
 * - si oui, renvoie l'indice correspondante
   - sinon, renvoie -1 */
int find_var(char* var,variables listevars) {
  int i;
  int ret;

  for (i=0; i<listevars.last; i++) {
    ret = strcmp(listevars.ident[i], var);
    if (ret==0) {
    return i;
    }
  }
  return -1;
}


/* Renvoie la valeur de l'identifiant var dans la liste listevars */
int value_var(char* var,variables listevars){
  int index = find_var(var,listevars);
  if (index == -1){
    fprintf(stderr,"Aucune valeur ne correspond à %s.\n",var);
    exit(1);
  }
  return listevars.val[index];
}


/* Modifie la valeur de la variable :
 * - Si "nom" fait partie de la liste des variables, alors la variable est
 *   directement modifiée
 * - Sinon rajoute le nom de la variable et sa valeur dans listevars
     si la taille de listevars le permet */
variables create_modif_var(char* nom, int val, variables listevars) {
  int index = find_var(nom,listevars);

  if (index != -1)
  {
    listevars.val[index] = val;
  }

  else{
  	if (listevars.last > TAILLE) {
    	printf("Il n'y a plus de place pour tous ces variables.\n");
    	exit(1);
  	}
  	else{
   	  listevars.ident[listevars.last] = malloc(strlen(nom)*sizeof(char));
    }

   	strcpy(listevars.ident[listevars.last],nom);
   	listevars.val[listevars.last] = val;
   	listevars.last++;
  }
  return listevars;

}
 /* ---------------> on peut y gérer l'unicité */
/* Incrémente la valeur de l'identifiant :
 * - si l'identifiant existe dans listevars, il incrémente la valeur existante
 * - sinon, il crée l'identifiant et l'initialise à 1
 * Utile pour listCOUNT */
variables increment_var(char* var,variables listevars){
  int index = find_var(var,listevars);

  if (index != -1)
    listevars.val[index] ++;

  else{
  	if (listevars.last > TAILLE) {
    	printf("Il n'y a plus de place pour tous ces variables.\n");
    	exit(1);
  	}
  	else{
   	  listevars.ident[listevars.last] = malloc(strlen(var)*sizeof(char));
    }

   	strcpy(listevars.ident[listevars.last],var);
   	listevars.val[listevars.last] = 1;
   	listevars.last++;
  }

  return listevars;
}

/******************************************************************************/
/* Fonctions de base de listevarpoint                                         */
/******************************************************************************/
varpoint init_listevarpoint(){
  varpoint res;
  res.last = 0;
  return res;
}


/* Vérifie si var est dans list :
 * - si oui, renvoie l'indice correspondante
   - sinon, renvoie -1 */
int find_varpoint(char* var,varpoint list) {
  int i;
  int ret;

  for (i=0; i<list.last; i++) {
    ret = strcmp(list.ident[i], var);
    if (ret==0) {
    return i;
    }
  }
  return -1;
}


/* Renvoie la valeur de l'identifiant var dans la liste list */
Point value_varpoint(char* var,varpoint list){
  int index = find_varpoint(var,list);
  if (index == -1){
    fprintf(stderr,"Aucune valeur ne correspond à %s.\n",var);
    exit(1);
  }
  return *(list.val[index]);
}


/* Modifie la valeur de la variable :
 * - Si "nom" fait partie de la liste des variables, alors la variable est
 *   directement modifiée
 * - Sinon rajoute le nom de la variable et sa valeur dans listevars
     si la taille de listevars le permet */
varpoint create_modif_varpoint(char* nom, Point val, varpoint list) {
  int index = find_varpoint(nom,list);

  if (index != -1)
  {
    *(list.val[index]) = val;
  }

  else{
  	if (list.last > TAILLE) {
    	printf("Il n'y a plus de place pour tous ces variables.\n");
    	exit(1);
  	}
  	else{
   	  list.ident[list.last] = malloc(strlen(nom)*sizeof(char));
      list.val[list.last] = malloc(sizeof(Point));
    }

   	strcpy(list.ident[list.last],nom);
   	*(list.val[list.last]) = val;
   	list.last++;
  }
  return list;

}


void check_obligatoire(variables listCount){
  if (find_var("IN",listCount) == -1){
    fprintf(stderr,"Erreur : IN n'existe pas.");
    exit(1);
  }

  if (find_var("OUT",listCount) == -1){
    fprintf(stderr,"Erreur : OUT n'existe pas.\n");
    exit(1);
  }

  if (find_var("SIZE",listCount) == -1){
    fprintf(stderr,"Erreur : SIZE n'existe pas.\n");
    exit(1);
  }
}


void show(Point size, Point in, Point** listOUT, Point** listWALL,
          Point** listTDV, varpoint** listPM, variables listCOUNT){
  char*** mat;
  int i,n;
  int index;
  Point pt;
  varpoint var;
  char s[100];

  /* Vérifie qu'on a des informations sur la taille, l'entrée et au moins
   * une sortie du labyrinthe */
  check_obligatoire(listCOUNT);
  mat = create_matrice(size.c,size.l);

  /* Ajout de l'entrée*/
  change_val_matrice(in,"E ",mat);

  /* Ajout des sorties */
  n=value_var("OUT",listCOUNT);
  for (i=0 ; i<n ; i++){
    pt = *(listOUT[i]);
    change_val_matrice(pt,"O ",mat);
  }

  /* Ajout des murs */
  n=value_var("WALL",listCOUNT);
  for (i=0 ; i<n ; i++){
    pt = *(listWALL[i]);
    change_val_matrice(pt,"* ",mat);
  }

  /* Ajout des trous de vers */
  n=value_var("TDV",listCOUNT);
  for (i=0 ; i<n ; i=i+2){
    pt = *(listTDV[i]);
    sprintf(s,"%d",i);

    char chaine1[100] = "W";
    char chaine2[100] = "w";
    strcat(chaine1,s);
    strcat(chaine2,s);

    change_val_matrice(pt,chaine1,mat);
    pt = *(listTDV[i+1]);
    change_val_matrice(pt,chaine2,mat);
  }

  /* Ajout des portes magiques */
  n = value_var("PM",listCOUNT);
  for (i=0 ; i<n ; i++){
    var = *(listPM[i]);
    index=find_varpoint("DEP",var);
    if (index==-1){
      fprintf(stderr,"Erreur : pas de point de départ de porte magique.\n");
      exit(1);
    }
    pt = value_varpoint("DEP",var);
    change_val_matrice(pt,"A ",mat);

    for (i=0 ; i<8 ; i++){
      if ((index = find_varpoint(DIR[i],var)) != -1){
        pt = value_varpoint(DIR[i],var);

        sprintf(s,"%d",i);
        char chaine1[100] = "a";
        strcat(chaine1,s);

        change_val_matrice(pt,chaine1,mat);
      }
    }
  }
  affichmat(mat,size);
}


/* Test des fonctions de base de la matrice et de listevars */
int main() {
  /* Tester varpoint */
  /*varpoint tmp;
  Point* tmp_pt;
  Point* tmp_pt2;
  tmp_pt = new_point_ptr(2,3);
  tmp_pt2 = new_point_ptr(2,4);
  tmp = init_listevarpoint();
  tmp = create_modif_varpoint("IDENT",*tmp_pt,tmp);
  tmp = create_modif_varpoint("IDENT",*tmp_pt2,tmp);
  Point res_value = value_varpoint("IDENT",tmp);
  printf("listevarpoint tmp : (%d,%d)\n",res_value.c,res_value.l);*/

  /*variables listLAB;
  variables listCOUNT;
  listLAB = init_listevars();
  listLAB = create_modif_var("SIZEc",5,listLAB);
  listLAB = create_modif_var("SIZEl",6,listLAB);
  listCOUNT = increment_var("SIZE",listCOUNT);
  listLAB = create_modif_var("INc",2,listLAB);
  listLAB = create_modif_var("INl",0,listLAB);
  listCOUNT = increment_var("IN",listCOUNT);
  listLAB = create_modif_var("OUTc",5,listLAB);
  listLAB = create_modif_var("OUTl",0,listLAB);
  listCOUNT = increment_var("OUT",listCOUNT);*/

  Point sizeLAB;
  Point in;
  Point** listOUT;
  Point** listWALL;
  Point** listTDV;
  varpoint** listPM;
  variables listCOUNT;

  sizeLAB = new_point(5,6);
  in = new_point(2,0);
  listOUT = init_tab(sizeLAB);
  listOUT = add_tab(new_point(0,5),listOUT,0);
  /*Ajouter paramètre incrémentation taille */
  listOUT = add_tab(new_point(5,0),listOUT,1);

  listWALL = init_tab(sizeLAB);
  listWALL = add_tab(new_point(3,0),listWALL,0);
  listWALL = add_tab(new_point(3,1),listWALL,1);
  listWALL = add_tab(new_point(4,2),listWALL,2);
  listWALL = add_tab(new_point(4,3),listWALL,3);
  listWALL = add_tab(new_point(5,4),listWALL,4);

  listTDV = init_tab(sizeLAB);
  listTDV = add_tab(new_point(3,4),listTDV,0);
  listTDV = add_tab(new_point(2,5),listTDV,1);
  listTDV = add_tab(new_point(0,1),listTDV,2);
  listTDV = add_tab(new_point(0,3),listTDV,3);

  int taille = (sizeLAB.c+1)*(sizeLAB.l+1);
  int i;
  listPM = calloc(taille,sizeof(varpoint*));
  for (i=0 ; i<taille ; i++){
    listPM[i] = malloc(sizeof(varpoint));
  }

  *listPM[0] = init_listevarpoint();
  *listPM[0] = create_modif_varpoint("DEP",new_point(3,2),*listPM[0]);
  *listPM[0] = create_modif_varpoint("W",new_point(0,0),*listPM[0]);
  *listPM[0] = create_modif_varpoint("E",new_point(5,2),*listPM[0]);


  listCOUNT = init_listevars();
  listCOUNT = increment_var("IN",listCOUNT); /*la fonction incrémente si points non identiques*/
  listCOUNT = increment_var("SIZE",listCOUNT);
  listCOUNT = increment_var("OUT",listCOUNT);
  listCOUNT = increment_var("OUT",listCOUNT);
  listCOUNT = increment_var("WALL",listCOUNT);
  listCOUNT = increment_var("WALL",listCOUNT);
  listCOUNT = increment_var("WALL",listCOUNT);
  listCOUNT = increment_var("WALL",listCOUNT);
  listCOUNT = increment_var("WALL",listCOUNT);
  listCOUNT = increment_var("TDV",listCOUNT);
  listCOUNT = increment_var("TDV",listCOUNT);
  listCOUNT = increment_var("TDV",listCOUNT);
  listCOUNT = increment_var("TDV",listCOUNT);
  listCOUNT = increment_var("PM",listCOUNT); /* on incrémente par porte d'entrée */


  show(sizeLAB,in,listOUT,listWALL,listTDV,listPM,listCOUNT);

  /*char*** matrice = create_matrice(5,6);

  Point p1 = new_point(4,2);
  printf("Point p1 (%d,%d)\n",p1.c,p1.l);

  printf("\nAppel de la fonction change_val_matrice(p1,ABC)\n");
  change_val_matrice(p1,"ABC",matrice);
  printf("Point p1 :%s\n", lecture(p1,matrice));
  printf("\nAppel de la fonction change_val_matrice(p1,DEF)\n");
  change_val_matrice(p1, "D", matrice);
  printf("Point p1 :%s\n", lecture(p1,matrice));

  printf("\nTaille de la matrice : (%d,%d)\n",size.c,size.l);
  printf("Matrice correspondante :\n");
  affichmat(matrice,size);

  listevars = init_listevars();
  listevars = create_modif_var("IDENT",1,listevars);
  listevars = create_modif_var("IDENT",2,listevars);
  listevars = create_modif_var("IDENT",1,listevars);
  listevars = create_modif_var("IDENT2",5,listevars);
  printf("Premier nom : %s\n",listevars.ident[0]);
  printf("Première valeur : %d\n",listevars.val[0]);
  printf("Deuxième nom : %s\n",listevars.ident[1]);
  printf("Deuxième valeur : %d\n",listevars.val[1]);*/

  return 0;
}
