
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "labgen.h"
int yylex(void);
FILE * yyin;
FILE * yyout;
char * yytext;
//extern char *** matrice;
char *** matrice = NULL;
extern variables listevars;

/* listeLAB contient les infos sur le labyrinthe */
extern variables listLAB;
/* listIDENT Contient la liste des IDENT (max par ex) et ses valeurs */
extern variables listIDENT;
/* listCOUNT compte le nombre de points pour chaque identifiant
 * Par exemple : 1 seul point pour IN et pour SIZE, 1 ou plus pour OUT*/
extern variables listCOUNT;
/* listOUT contiendra toutes les sorties OUT */
extern Point** listOUT;
extern Point size;
extern Point in; /*Point d'entrée du labyrinthe*/

void yyerror(const char *);

extern int yylineno;
char file[255];


%}


%union {
int cnum ;
char* ident;
char* op;
char* dir;
struct Point* point;
}



%token<ident> IDENT
%token<cnum> CNUM
%token  SIZE
%token<cnum> IN
%token<cnum> OUT WALL PTD SHOW UNWALL END R F PTA FOR TOGGLE WH MD
%token<op> OP
%token<dir> DIR
%type<cnum> xcst
%type<point> pt



%left  MULT DIV MOD
%left PLUS MOINS
%nonassoc NEG
%%

file:
listinstr {listLAB = init_listevars();
           listIDENT = init_listevars();
           listCOUNT = init_listevars(); } ;

listinstr:
instruction
|listinstr instruction
;

instruction:
IDENT '=' xcst END
  { listIDENT = create_modif_var($1,$3,listIDENT); }
|SIZE xcst END
  { listCOUNT = increment_var("SIZE",listCOUNT);
    listLAB = create_modif_var("SIZEc",$2,listLAB);
    listLAB = create_modif_var("SIZEl",$2,listLAB);
    size = new_point($2,$2); }
|SIZE xcst ',' xcst END
  { listCOUNT = increment_var("SIZE",listCOUNT);
    listLAB = create_modif_var("SIZEc",$2,listLAB);
    listLAB = create_modif_var("SIZEl",$4,listLAB);
    size = new_point($2,$4); }
|IN pt END

|WALL END
|TOGGLE END
|UNWALL END
|WALL R pt pt END
|TOGGLE R pt pt END
|UNWALL R pt pt END
|SHOW {
matrice = create_matrice(5,4);
size = new_point(5,4);

Point p1 = new_point(1,2);
change_val_matrice(p1, "E", matrice);
affichmat(matrice,size);

}


|OUT list END
|WALL PTA list END
|WALL R F pt pt END
|WALL PTD pt wallptd  END
|WALL FOR wallfor END
|UNWALL PTA list END
|UNWALL R F pt pt END
|UNWALL PTD unwallptd END
|UNWALL FOR unwallfor END
|TOGGLE PTA list END
|TOGGLE R F pt pt END
|TOGGLE PTD toggleptd END
|TOGGLE FOR togglefor END
|WH pt MOINS MOINS '>'pt list1 END
|WH pt MOINS '>'pt list1 END
|MD pt destlist END;

/*
expr:
xcst
|IDENT
|expr PLUS expr
|expr MOINS expr
|expr MULT expr
|expr DIV expr;
*/

xcst:
IDENT {$$ = value_var($1,listIDENT);}
|CNUM {$$ = $1;}
|PLUS CNUM {$$ = $2;}
|MOINS CNUM {$$ = -$2;}
|xcst PLUS xcst {$$ = $1 + $3;}
|xcst MOINS xcst {$$ = $1 - $3;}
|xcst MULT xcst {$$ = $1 * $3;}
| xcst DIV xcst {$$ = $1 / $3;}
| xcst MOD xcst {$$ = $1 % $3;}
| '(' xcst ')'  {$$ = $2;} ;





wallfor:
IDENT wallfor
|IN listRange pt;

unwallfor:
IDENT unwallfor
|IN listRange  pt;


togglefor:
IDENT togglefor
|IN listRange  pt;

toggleptd:
pt
|pt ':' r |
pt toggleptd
|pt ':' r toggleptd  ;





wallptd:
pt
|pt ':' r |
pt wallptd
|pt ':' r wallptd  ;

unwallptd:
pt
|pt ':' r |
pt unwallptd
|pt ':' r unwallptd;


r:
"*"
| xcst;

pt:  '('xcst ',' xcst')' {$$=new_point_ptr($2,$4);};


range:
'[' xcst  ':'  xcst ':'   xcst ']'
|'[' xcst  ':'  xcst ':'   xcst '['
| '['xcst  ':'  xcst '['
| '['xcst  ':'  xcst ']'
;

list:
|pt list
;


list1:
| MOINS MOINS '>' pt list1
;


destlist:
|DIR pt destlist;

listRange:
range
|range listRange;





%%

void yyerror(const char* mess){
    fprintf(stderr," %s:%i:syntaxe error (near %s) \n", file,yylineno,yytext);
    exit(1);
}

int main(int argc, char *argv[]){
    if (argc == 1){
      printf("A faire : lecture sur le flux standard d'entrée + exécutable labres\n");
    }

    else if (argc==2) {
        FILE *fp = fopen(argv[1],"r");
        if (fp!=NULL) {
	          strcpy(file,argv[1]);
            printf("Reading input from file succeded: %s\n",argv[1]);

            yyin = fp;
            /*listevars.last = 0;*/
            yyparse();
        }
        else {
            fprintf(stderr,"File doesn't exist.\n");
            exit(1);
        }
    }


   else if (argc == 3){
     listLAB = init_listevars();
     printf("A faire : lecture dans le fichier argc[1] + exécutable argc[2]\n");
    }

   else{
    	fprintf(stderr,"usage: %s OR %s if OR %s if exe\n",
          argv[0],argv[0],argv[0]);
    	exit(1);
   }

    return 0;
}
