#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "labgen.h"

/******************************************************************************/
/* Fonctions de base de listevarpoint                                         */
/******************************************************************************/
varpoint init_listevarpoint(){
  varpoint res;
  res.last = 0;
  return res;
}


/* Vérifie si var est dans list :
 * - si oui, renvoie l'indice correspondante
   - sinon, renvoie -1 */
int find_varpoint(char* var,varpoint list) {
  int i;
  int ret;

  for (i=0; i<list.last; i++) {
    ret = strcmp(list.ident[i], var);
    if (ret==0) {
    return i;
    }
  }
  return -1;
}


/* Renvoie la valeur de l'identifiant var dans la liste list */
Point value_varpoint(char* var,varpoint list){
  int index = find_varpoint(var,list);
  if (index == -1){
    fprintf(stderr,"Aucune valeur ne correspond à %s.\n",var);
    exit(1);
  }
  return *(list.val[index]);
}


/* Modifie la valeur de la variable :
 * - Si "nom" fait partie de la liste des variables, alors la variable est
 *   directement modifiée
 * - Sinon rajoute le nom de la variable et sa valeur dans listevars
     si la taille de listevars le permet */
varpoint create_modif_varpoint(char* nom, Point val, varpoint list) {
  int index = find_varpoint(nom,list);

  if (index != -1)
  {
    *(list.val[index]) = val;
  }

  else{
  	if (list.last > TAILLE) {
    	printf("Il n'y a plus de place pour tous ces variables.\n");
    	exit(1);
  	}
  	else{
   	  list.ident[list.last] = malloc(strlen(nom)*sizeof(char));
      list.val[list.last] = malloc(sizeof(Point));
    }

   	strcpy(list.ident[list.last],nom);
   	*(list.val[list.last]) = val;
   	list.last++;
  }
  return list;

}
